<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\UserPhysicRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\Physical;
use App\SystemPhysic;
use App\ReservationPhyscal;
use App\TrainnerReservation;

class UserPhysicController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/userphysics';
    /** View folder */
    private $viewDirectory= 'admin.userphysics.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('userphysics.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the userphysics.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $ids = TrainnerReservation::pluck('patient_id');
        $query = User::whereIn('id',$ids)->orderBy('id', 'DESC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $userphysics= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('userphysics'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('userphysics.store');
        $head = metaFields('userphysics', 'add_new', getCurrentLocale()) ?? __('userphysics.new');
        
        $patients = User::where('role_id','6')->get();

        return view( $this->viewDirectory.'form', compact('action', 'head','patients') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param UserPhysicRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(Request $request) :RedirectResponse
    {
     

        $this->saveData( $request, $request->user_id );
        
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  UserPhysic  $userphysic
     * @return View
     */
    public function edit(User $userphysic): View
    {
        $action= route('userphysics.update', $userphysic->id);
        $head = metaFields('userphysics', 'edit', getCurrentLocale()) ?? __('userphysics.edit');
        
        $patients = User::where('role_id','6')->get();
        $userphysics = TrainnerReservation::where('patient_id',$userphysic->id)->get();
        $systemphysics = SystemPhysic::cursor();
        $physicals = Physical::cursor();
        return view( $this->viewDirectory.'form', compact('userphysic','physicals', 'userphysics','action', 'head','patients','systemphysics') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  UserPhysicRequest  $request
     * @param  TrainnerReservation  $userphysic
     * @return RedirectResponse|Redirector
     */
    public function update(Request $request, User $userphysic) :RedirectResponse
    {
      
        TrainnerReservation::where('patient_id',$userphysic->id)->delete();
        $this->saveData( $request, $request->user_id );
		
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }
    
    
    private function saveData(Request $request, int $id ):void
    {
        
       if (!is_null($request->physical))
       {
           
            foreach ($request->physical as $row)
            {
                if(is_null($row['dating'])){
                    $date = date('Y-m-d');
                }
                else{
                    $date = $row['dating'];
                }
              $reserve = TrainnerReservation::create([
            'patient_id'=>$id,
            'dating'=>$date,
            'system_physic_id'=>$row['system_physic_id'],
            'code_id'=>$row['code_id'],
            
           
                                            ]);

        if(isset($row['physicals'])){
            foreach ($row['physicals'] as $rows)
            {
             ReservationPhyscal::create([
            'user_id'=>$id,
            'physcal_id'=>$rows['physcal_id'],
            'num'=>$rows['num'],
            'reservation_id'=>$reserve['id'],
            
           
                                            ]);
        }
        }



            
              
            }
        }

    }
    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = TrainnerReservation::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            TrainnerReservation::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            TrainnerReservation::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = TrainnerReservation::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = TrainnerReservation::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
